<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Basis\Kursdetails\DetailsReiter\Teilnehmer\SammelEinzelBearbeitung;

use Kufer\KuferTools\Basis\UseCase\EinzelKursUseCase;
use Kufer\KuferTools\Utils\ResponseStrategies\ResponseMitRahmen;
use Kufer\KuferTools\Utils\ResponseStrategies\ResponseWssSammelEinzelnFormularStrategy;

abstract class SammelEinzelBearbeitungFormularUseCase extends EinzelKursUseCase
{
  public function __construct($request, $response = null)
  {
    parent::__construct($request, $response ?? new SammelEinzelBearbeitungFormularResponse());
  }

  public function hasAccess($pToolsectionId = null)
  {
    if (is_null($this->request->belegungen) && !is_array($this->request->belids)) {
      return false;
    }

    if (!parent::hasAccess($pToolsectionId)) {
      return false;
    }

    if (!empty($this->request->belids)) {
      $alleIds = $this->getBelegungenIdsOhneFilter();
      foreach ($this->request->belids as $tnr) {
        if (!in_array($tnr, $alleIds)) {
          return false;
        }
      }
    }

    return true;
  }

  public function action()
  {
    $this->handleResponseStrategies();

    $this->response->kurs = $this->getKurs($this->getRequestedId());

    $this->response->referer = $this->getBackLink();
    $this->response->refererLabel = $this->getBackButtonLabel();
    $this->response->status = $this->request->status;

    return $this->response;
  }

  protected function getBackLink(): string
  {
    return 'index.php?tool_id=' . static::getToolId() . '&action=kursdetails&knr=' . $this->request->knr . '#reiterTeilnehmer';
  }

  protected function getBackButtonLabel(): string
  {
    return 'Zurück';
  }

  abstract public static function getDescriptionToolSectionId(): int;

  abstract public static function getFormToolSectionId(): int;

  protected function getResponseStrategies()
  {
    return array_merge(
      parent::getResponseStrategies(),
      array(
        new ResponseMitRahmen($this),
        new ResponseWssSammelEinzelnFormularStrategy(
          $this,
          $this->getDescriptionToolSectionId(),
          $this->getFormToolSectionId(),
          $this->getBelegungen()
        )
      )
    );
  }

  protected function getBelegungen(): array
  {
    if (!is_null($this->request->belegungen)) {
      return $this->request->belegungen;
    }

    return $this->getBelegungsHelper($this->getKurs($this->getRequestedId()))->getDatamoduleByIds($this->getBelegungenIds());
  }

  
  protected function getBelegungenIds(): array
  {
    if (!is_null($this->request->belegungen)) {
      return \ArrayOperations::mapAttribut($this->request->belegungen, 'id');
    }

    if (empty($this->request->belids)) {
      return $this->getBelegungenIdsOhneFilter();
    }

    return $this->request->belids;
  }

  
  protected function getBelegungenIdsOhneFilter(): array
  {
    return $this->getBelegungsHelper($this->getKurs($this->getRequestedId()))->getIdsOhneFilter();
  }

  protected function getBelegungsHelper(\Kurs $kurs): \Kufer\KuferTools\Utils\DatamodulHelper\BelegungsHelper\BelegungsHelper
  {
    return new \Kufer\KuferTools\Utils\DatamodulHelper\BelegungsHelper\ReiterTeilnehmerBelegungen($this->toolSettings, $this->request, $kurs->id);
  }
}

class SammelEinzelBearbeitungFormularRequest
{
  public $knr;
  public $belids; 
  public $status; 
  public $belegungen; 
}

class SammelEinzelBearbeitungFormularResponse extends \Kufer\KuferTools\Utils\ResponseStrategies\SammelEinzelnFormularResponse
{
  public $kurs;
  public $referer;
  public $refererLabel;
  public $status;
}